// GrowthTool2  an Illustrator script for Scriptographer 
// 
// Based on example script but ...
//    more parameters
//    generates a single path not a group so more style options
//    shares common processing with Growth2
//
// gw@westdale.demon.co.uk
//
// Interesting patterns with scale = 1, roation = 360/n and maxrep = n-1
//
// some oddities with scale = 1 -  hack put in to be just less than 1


// Mouse handling ----------------------------------

var path;  

function onMouseDown(event) {
	path = new Path();
	path.add(event.point);
}

function onMouseDrag(event) {
	path.add(event.point);
}

function onMouseUp(event) {
    ProcessPath(path)
} 


// Interface ---------------------------


var values = {
	scale: 0.95,
	smooth: 10,
	maxrep: 25,
	minlength: 10,
	autorotate: true,
	rotate:-90,
};

var components = {
	scale: {
		label: 'Scale',
		type: 'number',
		range: [0.1, 1]
	},
	smooth: {
		label: 'Smooth',
		type: 'number',
		range: [0,1000]
	},
	maxrep: {
		label: 'max reps',
		type: 'number',
		range: [1,200]
	},
	minlength: {
		label: 'min length',
		type: 'number',
		range: [1,200]
	},
	autorotate: {
		label:'autorotate', 
		value: true, 
		type: 'boolean'
	},
	rotate: {
		label: 'angle', 
		type: 'number'
	}
};

var palette = new Palette('Grow', components, values);


// Main process ------------------------------------------


function ProcessPath(path) {
	 // common code with GrowthTool script

	// get frequently used params
	var scale = values.scale;
	// HACK: transform can be upset by scale = 1 and angle = 90, 45 etc 
	if (scale == 1){ scale = 0.9999 }  
	var autorotate = values.autorotate;
	var rotate = values.rotate;
	var minlength = values.minlength;
	var maxrep = values.maxrep;
	
	// smooth the hand drawn curve
	path.pointsToCurves(values.smooth);

	var nextseg = path.clone();   
	for(var i = 0; i < maxrep; i++) {

		var lastCurve = path.curves.last;
		var point2 = lastCurve.getPoint(1);
		var angle2 = lastCurve.getTangent(1).angle;

		nextseg.scale(scale);

		var firstB = nextseg.curves[0];
		var point1 = firstB.getPoint(0);
		var angle1 = firstB.getTangent(0).angle;

		var angle;
		if (autorotate){
			 angle =  angle2 - angle1
		} else {
			angle = rotate;
		}	

		nextseg.rotate(angle, point1);	
		

		nextseg.position += point2 - point1;

		if (nextseg.length < minlength) {
		   break;
		} else {
		  path.join( nextseg.clone() );
		}
		
	} // loop repetitions
	
   nextseg.remove(); // remove the working segment
   
} // fn ProcessPath

